/*   WMF
  1998*/
#include<stdio.h>

int bufcmp(buf1,buf2,n)
char *buf1,*buf2;
int n;
{
int k;
for(k=0;k<n;k++)
	{ 
	if(buf1[k]!=buf2[k]) return(-1);
	}
return(1);
}


/*   */
int form=0;
char vers[]="0.05";
char logo[]="wmf2\nAnton V. Boyarshinov 1998\nversion ";
 
char help[]="\n Usage:	..... [POSIX or GNU style opions] [-- infile]\n\
		or	..... [POSIX or GNU style opions] <infile >outfile\n\
	POSIX options:		GNU long options:\n\
	-W copyright		--copyright\n\
	-W help			--help\n\
	-W usage		--usage\n\
	-W version		--version\n\
	-o outfile		--output outfile\n\
	-xf			--xfig\n\
	-eps			--eps (default)";

char copyright[]="Copyright (C) 1998, Anton V. Boyarshinov\n\n\
This program is free software; you can redistribute it and/or modify\
it under the terms of the GNU General Public License as published by\
the Free Software Foundation; either version 2 of the License, or\
(at your option) any later version.\n\n\
This program is distributed in the hope that it will be useful,\
but WITHOUT ANY WARRANTY; without even the implied warranty of\
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\
GNU General Public License for more details.\n";

int arguments(int num,char* args[])
{
int i,j,k,l,m,n,W,is_q=0;
for(i=1;i<num;i++)
	{
	W=0;
	if(bufcmp(args[i],"-W",2)==1){W=1;i++;}
	if(bufcmp(args[i],"--copyright",10)==1||(bufcmp(args[i],"copyright",9)==1&&W==1))
		{fprintf(stderr,"%s",copyright);
		exit(0);
		}
	if(bufcmp(args[i],"--version",8)==1||(bufcmp(args[i],"version",7)==1)&&W==1){fprintf(stderr,"\n%s\n",vers);exit(0);}
	if(bufcmp(args[i],"--usage",7)==1||bufcmp(args[i],"--help",6)==1||
		bufcmp(args[i],"-h",2)==1||bufcmp(args[i],"-?",2)==1||
		((bufcmp(args[i],"usage",5)==1||bufcmp(args[i],"help",4)&&W==1))==1
		){fprintf(stderr,"\n%s\n",help);exit(0);}
	if(bufcmp(args[i],"--quiet",7)==1||(bufcmp(args[i],"-q",2)==1))
		{is_q=1;continue;
		}
	if(bufcmp(args[i],"--xfig",7)==1||(bufcmp(args[i],"-xf",2)==1))
		{form=1;continue;
		}
	if(bufcmp(args[i],"--eps",7)==1||(bufcmp(args[i],"-eps",2)==1))
		{form=1;continue;
		}
	if(bufcmp(args[i],"--output",8)==1||(bufcmp(args[i],"-o",2)==1))
		{i++;
		freopen(args[i],"w",stdout);
		continue;
		}
	if(bufcmp(args[i],"--",2)==1){i++;break;}
	break;
	}
if(is_q==0)fprintf(stderr,"\n%s %s\n",logo,vers);
if(i<num){if(freopen(args[i],"r",stdin)==0)
	{fprintf(stderr,"\nUnable to open file %s\n",args[i]);exit(-1);}i++;}
if(i<num){freopen(args[i],"w",stdout);}
return(0);
}

unsigned char functs[4096][64];
unsigned char buf0;
short unsigned int *buf1,code,head_buf[64];
short unsigned int args[4096];
short int *args2;
int *buf3,*buf4,size_w,X1,X2,Y1,Y2,DPI,SIZE_F,SIZE_W,object;
unsigned char *buf2,*R,*G,*B,*A,*args_s;
int i,j,k,l,m;//i   ; j ;k  

int init()
{
sprintf(functs[0x436],"AnimatePalette");
sprintf(functs[0x817],"");
sprintf(functs[0x922],"BitBlt");
sprintf(functs[0x940],"BitBlt3");
sprintf(functs[0x830],"");
sprintf(functs[0x2fc],"CreateBrushIndirect");
sprintf(functs[0x2fb],"CreateFontIndirect");
sprintf(functs[0xf7],"CreatePalette");
sprintf(functs[0x1f9],"CreatePatternBrush");
sprintf(functs[0x142],"CreatePatternBrush3");
sprintf(functs[0x2fa],"CreatePenIndirect");
sprintf(functs[0x6ff],"CreateRegion");
sprintf(functs[0x1f0],"DeleteObject");
sprintf(functs[0x62f],"DrowText");
sprintf(functs[0x418],"Ellipse");
sprintf(functs[0x626],"Escape");
sprintf(functs[0x415],"ExcludeClipRect");
sprintf(functs[0xa32],"ExtTextOut");
sprintf(functs[0x419],"FloodFill");
sprintf(functs[0x416],"IntersectClipRect");
sprintf(functs[0x213],"LineTo");
sprintf(functs[0x214],"MoveTo");
sprintf(functs[0x220],"OffsetClipRgn");
sprintf(functs[0x211],"OffsetViewportOrg");
sprintf(functs[0x20f],"OffsetWindowOrg");
sprintf(functs[0x61d],"PatBlt");
sprintf(functs[0x81a],"Pie");
sprintf(functs[0x324],"Polygon");
sprintf(functs[0x325],"Polyline");
sprintf(functs[0x538],"PolyPolygon");
sprintf(functs[0x35],"RealasePalette");
sprintf(functs[0x41b],"Rectangle");
sprintf(functs[0x139],"ResizePalette");
sprintf(functs[0x127],"RestoreDC");
sprintf(functs[0x61c],"RoundRect");
sprintf(functs[0x1e],"SaveDC");
sprintf(functs[0x412],"ScaleViewportExt");
sprintf(functs[0x400],"ScaleWindowExt");
sprintf(functs[0x12c],"SelectClipRgn");
sprintf(functs[0x12d],"SelectObject");
sprintf(functs[0x234],"SelectPalette");
sprintf(functs[0x201],"SelectBkColor");
sprintf(functs[0x102],"SetBkMode");
sprintf(functs[0xd33],"SetDIBitsToDev");
sprintf(functs[0x103],"SetMapMode");
sprintf(functs[0x231],"SetMapperFlags");
sprintf(functs[0x37],"SetPaletteEntrs");
sprintf(functs[0x41f],"SetPixel");
sprintf(functs[0x106],"SetPolyFillMode");
sprintf(functs[0x104],"SetROP2");
sprintf(functs[0x107],"SetStretchBlttMode");
sprintf(functs[0x12e],"SetTextAlign");
sprintf(functs[0x108],"SetTextCharExtra");
sprintf(functs[0x209],"SetTextColor");
sprintf(functs[0x20a],"SetTextJustification");
sprintf(functs[0x20e],"SetViewportExt");
sprintf(functs[0x20d],"SetViewportOrg");
sprintf(functs[0x20c],"SetWindowExt");
sprintf(functs[0x20b],"SetWindowOrg");
sprintf(functs[0xb23],"StretchBlt");
sprintf(functs[0xb41],"StretchBlt3");
sprintf(functs[0xf43],"StretchDIBits");
sprintf(functs[0x521],"TextOut");
}

int fontmp[64][2]; 
unsigned char Fontmp[255][2][64];
int Fontmap()
{
FILE *filen;
char filename[]="/usr/local/lib/wmf2/Fontmap";
char winfont[255],psfont[255],filebuf[4096];
int i=0,o=1;
char test[]="Courier New Cyr=Coutier;\nCourier2=Coutier;\n";
int res;
if((filen=fopen(filename,"r"))==NULL)
	{fprintf(stderr,"\nUnable to open file %s, exiting\n",filename);exit(-1);}
//clearerr(filen);
while(feof(filen)==0)
	{//filebuf[i]=getc(filen);
	res=fscanf(filen,"%[^=]=%n",winfont,&fontmp[i][0]);
	res=fscanf(filen,"%[^;];\n%n",psfont,&fontmp[i][1]);
//fprintf(stderr,"\n%s=\n%s;\n",winfont,psfont);
	sprintf(Fontmp[i][0],"%s",winfont);
	sprintf(Fontmp[i][1],"%s",psfont);
	i++;
	}

fclose(filen);
return(0);
}



int toXF()
{
printf("#FIG 2.1\n80 1\n");
j=0;
while(j<i)
	{
	if(j%2==0)size_w=buf3[j/2];else size_w=buf4[j/2+1];
	if(size_w>SIZE_W||size_w<0){fprintf(stderr,"error\n");exit(-3);}
	code=buf1[j+2];//j=j+size_w;
/*	if(code==0x104)
		{buf1=buf2-1;
		buf2=buf1;
		buf3=buf1;
		buf4=buf1-1;
		}*/
	j=j+3;size_w=size_w-3;
	for(l=0;l<size_w;l++)
		{args[l]=buf1[j+l];
		}
	j=j+l;
	if(code==0x324)
		{
		printf("2 2 0 1 -1 0 0 0 0.000 0 0 0\n          ");
		for(m=1;m<args[0]*2;m+=2)printf("%i %i ",(args2[m]-X1)/8,(args2[m+1]-Y1)/8);
		printf("9999 9999\n");
		}
	if(code==0x325)
		{printf("2 1 0 1 -1 0 0 0 0.000 0 0 0\n          ");
		for(m=1;m<args[0]*2;m+=2)printf("%i %i ",(args2[m]-X1)/8,(args2[m+1]-Y1)/8);
		printf("9999 9999\n");
		}
/*	if(code==0x2fc)
		{
		B=&args[1];G=&args[1]+1;R=&args[2];A=&args[2]+1;
//		fprintf(stdout,"%x %x %x %x %x %x\n",args[0],args[1],args[2],args[3],args[4],args[5]);
		printf("%d %d %d setrgbcolor%% %d\n",*R,*G,*B,*A);
		}*/
//	fprintf(stderr,"; %i\nsize=%i;(0x%x)\nfunct=0x%x;(%s)\n",k,size_w,size_w,code,functs[code]);k++;
	}
//fputc(filebuf2[j],stdout);
//fprintf(stderr,"%d\n",i);
//printf("showpage\n");
}


int toPS()
{
int is_bold=0,wei=0;
char bold[4][16];
sprintf(bold[0],"\0\0\0");
sprintf(bold[1],"-Bold");
sprintf(bold[2],"-Italic");
sprintf(bold[3],"-BoldItalic");


printf("%%!PS-Adobe-2.0 EPSF\n%%%%Creator: wmf2\n%%%%BoundingBox: 0 0 %i %i\n\
%%%%Pages: 0\n%%%%EndComments\n",(X2-X1)*72/DPI,(Y2-Y1)*72/DPI);
printf("%f %f scale\n",(double)72/DPI,(double)72/DPI);
j=0;
while(j<i)
	{
	if(j%2==0)size_w=buf3[j/2];else size_w=buf4[j/2+1];
//	if(size_w>SIZE_W||size_w<0){fprintf(stderr,"error\n");exit(-3);}
	code=buf1[j+2];
	if(code==0)break;
	//fprintf(stderr,"; %i\nsize=%i;(0x%x)\nfunct=0x%x;(%s )\n",k,size_w,size_w,code,functs[code]);k++;
	if(size_w>SIZE_W||size_w<0){fprintf(stderr,"error\n");exit(-3);}
	j=j+3;size_w=size_w-3;
	for(l=0;l<size_w;l++)
		{args[l]=buf1[j+l];
		}
	j=j+l;
	if(code==0x324)
		{
		printf("%i %i moveto\n",args2[1]-X1,Y2-args2[2]);
		for(m=3;m<args[0]*2;m+=2)printf("%i %i lineto\n",args2[m]-X1,Y2-args2[m+1]);
		printf("fill\n");
		}
	if(code==0x325)
		{
		printf("%i %i moveto\n",args[1]-X1,Y2-args[2]);
		for(m=3;m<l;m+=2)printf("%i %i lineto\n",args[m]-X1,Y2-args[m+1]);
		printf("stroke\n");
		}

	if(code==0xa32)
		{
		args_s=&args[0];
		printf("%d %d moveto%% %d\n(",args[1],args[0],l);
		for(m=8;m<l*2;m++)
			{if(args_s[m]==0)break;
			if(args_s[m]!=')'&&args_s[m]!='(')fputc(args_s[m],stdout);
			else {fputc('\\',stdout);fputc(args_s[m],stdout);}
			
			}
		printf(") show\n");
		}
	if(code==0x521)
		{
		args_s=&args[1];
		if(args[0]%2==0)
			printf("%i %i moveto%% %d\n(",args[args[0]/2+2],(Y2-args[args[0]/2+1])*2,l);
		else
			printf("%i %i moveto%% %d\n(",args[args[0]/2+3],(Y2-args[args[0]/2+2])*2,l);
		for(m=0;m<args[0];m++)fputc(args_s[m],stdout);
		printf(") show\n");
		}
	if(code==0x2fc)
		{
		B=&args[1];G=&args[1]+1;R=&args[2];A=&args[2]+1;
//		fprintf(stdout,"%x %x %x %x %x %x\n",args[0],args[1],args[2],args[3],args[4],args[5]);
		printf("/col%d {%d %d %d setrgbcolor} def%% %d\n",object,*R,*G,*B,*A);
		object++;
		}
	if(code==0x2fa)
		{
		B=&args[1];G=&args[1]+1;R=&args[2];A=&args[2]+1;
//		fprintf(stdout,"%x %x %x %x %x %x\n",args[0],args[1],args[2],args[3],args[4],args[5]);
		printf("/col%d {%d %d %d setrgbcolor} def%% %d\n",object,*R,*G,*B,*A);
		object++;
		}
	if(code==0x2fb)
		{
//		args_s=&args[10]
		for(m=0;m<255;m++)
			{if(bufcmp(Fontmp[m][0],&args[9],fontmp[m][0])==1)
				{memcpy(&args[9],Fontmp[m][1],fontmp[m][1]);
				break;
				}
			}
		if(args[0]==0)args[0]=1000;
		if(args[4]==700)is_bold=1;
		if(args[5]!=0)wei=2;
		wei=wei+is_bold;
		printf("/col%d {/%s%s findfont %d scalefont setfont} def\n",object,&args[9],bold[wei],args[0]/150);
		object++;
		}
	if(code==0x12d)
		{printf("col%d\n",args[0]);
		}

	}
//fputc(filebuf2[j],stdout);
//fprintf(stderr,"%d\n",i);
printf("showpage\n");
}





main(int argc,char* argv[])
{
int *buf5;

i=0;
arguments(argc,argv);
init();
args2=args;
buf2=head_buf;
buf3=head_buf;
buf4=head_buf-1;
for(i=0;i<40;i++)
	{buf0=getc(stdin);
	buf2[i]=buf0;
	buf0=fgetc(stdin);i++;
	buf2[i]=buf0;
	}
i=(i-2)/2;
if(head_buf[0]==0xCDD7&&head_buf[1]==0x9AC6)
	{X1=head_buf[3];
	Y1=head_buf[4];
	X2=head_buf[5];
	Y2=head_buf[6];
	DPI=head_buf[7];
	SIZE_F=buf3[7];
	SIZE_W=buf4[9];
buf1=malloc(SIZE_F*3);
if(buf1==0){fprintf(stderr,"Out of memory\n");exit(-2);}
	i=0;
	}
	else
	if(head_buf[0]==0x01&&head_buf[1]==0x09)
		{X1=0;X2=0,Y1=0,Y2=0;DPI=1000;
		i=22;
		buf5=head_buf-11;
		buf2=buf5;
		buf3=buf5;
		buf4=buf5-1;
//fprintf(stderr,"point0\n");
SIZE_F=buf3[7];
SIZE_W=buf4[9];
buf1=malloc(SIZE_F*3);
if(buf1==0){fprintf(stderr,"Out of memory\n");exit(-2);}		
		memcpy(buf1,buf5+10,22);
//		fprintf(stderr,"point1\n");
		}
		else
		{fprintf(stderr,"\nFile is not in WMF format\n");exit(-1);}
//fprintf(stderr,"SIZE_F=%x\n\n",SIZE_F);
buf2=buf1;
buf3=buf1;
buf4=buf1-1;
//i=0;
for(i=i;i<SIZE_F*3;i++)
	{buf0=getc(stdin);
	buf2[i]=buf0;
	buf0=getc(stdin);i++;
	buf2[i]=buf0;
	if(feof(stdin)==1)break;
	}
i=(i-2)/2;
//for(j=0;j<i*2;j++)fputc(buf2[j],stderr);j=0;
Fontmap();
if(form==0)toPS();else toXF();
}